

/******  BOSS RC-1 FADE (P. GIORGIO 2020 - Covid-19 time)
          - Fade function
           - Rotary Encoder Volume
             - RGB LED for volume visual control
               - Integrated Stop Push-Button
                                                    *****/
#include <EEPROM.h>

/***********************MCP42XXX Commands************************/
#include <SPI.h>     
const int CS_PIN = 10;             // set pin 10 as the slave select (SS) for the digital Potenziometer MCP42100
int potValue = EEPROM.read(0);     // pot value stored by pressing encoder push button!;                      // stored value of the digital Potenziometer 
int pot;                           // value of the digital Potenziometer MCP42100 (255 --> 3.3V. --> min MOD) 
const int POT0_SEL = 0x11;         // command to the digital potenziometer 0 pin(8-9-10)
const int POT1_SEL = 0x12;         // command to the digital potenziometer 1 pin(5-6-7)
const int BOTH_POT_SEL = 0x13;     // command to the digital potenziometers 0+1 pin(5-6-7)+(8-9-10)
/***********************MCP42XXX Commands************************/

int timeFade = 150;     // time of Fade out 
int fade = 0;           // fade counter
int potFade = potValue; // starting value when FADE with external switch
float lenghtPush = 0;   // how long the Foot Switch has been pressed
int shortPush = 100;    // short press -> STOP
int longPush = 450;     // long press  -> FADE function

static int pinA = 2;            // First hardware interrupt pin is digital pin 2  -> Encoder signal A   ->
static int pinB = 3;            // Second hardware interrupt pin is digital pin 3 -> Encoder signal B   ->
static int encoderButton = 4;   // Encoder Push Button D4                                               ->  for all the INPUT the COMMON is on the GND
int encoderPos = potValue;      // to set at the same value stored in the EEPROM
int previousEncoderPos = 0;
volatile byte pinALast = HIGH;
volatile byte stateA = HIGH;
int encoderButtonState = 0;     // read the encoderButton


static int reedStop = 7;        // output to Reed (NO) in parallel with tip of STOP jack and GND                                      -> 
const int fadeRing = 8;         // input (diode) from ring jack
const int stopTip = 12;         // input (diode) from tip jack
int stopState = 0;
int ringState = 0;
int stopCount = 0;
int noExt = 1;                  // external STOP switch not connected (default)
int noRing = 1;                 // external RING switch not connected (default) - UNDO/REDO

int Count = 0;
int inter = 0;

const int ledRed = 5;           // RED   1) STOP pressed
const int ledGreen = 9;         // GREEN 1) Ready to FADE 2) after STOP+Clean
const int ledBlue = 6;          // BLUE  1) Fade-in-progress

  
void setup() {

// Serial.begin(9600);  

  pinMode(CS_PIN, OUTPUT);     // set the CS_PIN as an output:
  SPI.begin();                 // initialize SPI:
  
   
  pinMode(encoderButton, INPUT_PULLUP); // set Encoder Push Button
  pinMode(pinA, INPUT_PULLUP);          // set pinA encoder CHANNEL A
  pinMode(pinB, INPUT_PULLUP);          // set pinB encoder CHANNEL B 
  pinMode(fadeRing, INPUT_PULLUP);      // set ring input
  pinMode(stopTip, INPUT_PULLUP);       // set tip input
  pinMode(reedStop, OUTPUT);            // Contact STOP (NO)
          
               stopState = digitalRead(stopTip);
               delay(10);
               if(stopState == LOW){noExt = 0;}  // check if external STOP switch connected
        
        digitalWrite(reedStop, noExt); 

               ringState = digitalRead(fadeRing);
               delay(10);
               if(ringState == LOW){noRing = 0;}  // check if external FADE (RING) switch connected


  pinMode(ledBlue, OUTPUT);
  pinMode(ledRed, OUTPUT);
  pinMode(ledGreen, OUTPUT);
  
 // pinMode(A0, OUTPUT);
 // pinMode(A1, OUTPUT);
 // pinMode(A2, OUTPUT);
 // pinMode(A3, OUTPUT);
 // pinMode(A4, OUTPUT);
 // pinMode(A5, OUTPUT);
 // pinMode(A6, OUTPUT);
 // pinMode(A7, OUTPUT);

      
attachInterrupt(digitalPinToInterrupt(pinB),PinB,RISING);  // set an interrupt on PinB, looking for a RISING edge signal and executing the "PinB" Interrupt Service Routine (below)  
attachInterrupt(digitalPinToInterrupt(pinA),PinA,FALLING); // set an interrupt on PinA, looking for a FALLING edge signal and executing the "PinA" Interrupt Service Routine (below)

            }

      void PinA(){
        cli(); //stop interrupts happening before we read pin values
        stateA = digitalRead(pinA);
 
       if ((pinALast == HIGH) && (stateA == LOW)) {
          if (digitalRead(pinB) == HIGH) {  
            if(encoderPos <= 21) {encoderPos = 21;}
      encoderPos = encoderPos - 21;
           } else {
             if(encoderPos >= 234) {encoderPos = 234;}
      encoderPos = encoderPos + 21;
                   }
                                                  }
       pinALast = stateA;
       sei(); //restart interrupts
            }

       void PinB(){
        cli(); //stop interrupts happening before we read pin values
        stateA = digitalRead(pinA);
 
       if ((pinALast == HIGH) && (stateA == LOW)) {
          if (digitalRead(pinB) == HIGH) {  
            if(encoderPos <= 21) {encoderPos = 21;}
      encoderPos = encoderPos - 21;
           } else {
             if(encoderPos >= 234) {encoderPos = 234;}
      encoderPos = encoderPos + 21;
                   }
                                                   }
       pinALast = stateA;
       sei(); //restart interrupts
            }
                

void DigitalPotWrite(int cmd, int val){
  val = constrain(val, 0, 255);         // constrain input value within 0 - 255
  digitalWrite(CS_PIN, LOW);            // set the CS pin to low to select the chip
  SPI.transfer(cmd);                    // send the command and value via SPI
  SPI.transfer(val);                    // send the command and value via SPI  
  digitalWrite(CS_PIN, HIGH);           // Set the CS pin high to execute the command:
                                      }

void Green(){
  analogWrite(ledBlue, 0); 
  analogWrite(ledRed, 0); 
  analogWrite(ledGreen, 255); 
          }

void Blue(int Blue){
  analogWrite(ledBlue, Blue); 
  analogWrite(ledRed, 0); 
  analogWrite(ledGreen, 0);
          }

void Red(){
  analogWrite(ledBlue, 0); 
  analogWrite(ledRed, 255); 
  analogWrite(ledGreen, 0); 
          }

void RGB(int Vol){
 
  if(Vol > 127){analogWrite(ledBlue, 500-(Vol*2));}
  else{analogWrite(ledBlue, (Vol*3)-100);}
  
  analogWrite(ledRed, (Vol*2)-200); 
  analogWrite(ledGreen, 255-Vol); 

  previousEncoderPos = encoderPos;
  potFade = encoderPos; 
                  }

void RGBall(int Int){
  analogWrite(ledBlue, Int); 
  analogWrite(ledRed, Int); 
  analogWrite(ledGreen, Int); 
          }

// void ledVol(int Vol){
//    digitalWrite(A0, LOW);
//    digitalWrite(A1, LOW);
//    digitalWrite(A2, LOW);
//    digitalWrite(A3, LOW);
//    digitalWrite(A4, LOW);
//    digitalWrite(A5, LOW);
//    digitalWrite(A6, LOW);
//    digitalWrite(A7, LOW);
//    
//    switch (Vol){
//      case 0:
//      digitalWrite(A0, HIGH);
//      break;
//         case 1:
//         digitalWrite(A1, HIGH);
//         break;
//            case 2:
//            digitalWrite(A2, HIGH);
//            break;
//               case 3:
//               digitalWrite(A3, HIGH);
//               break;
//                  case 4:
//                  digitalWrite(A4, HIGH);
//                  break;
//                     case 5:
//                      digitalWrite(A5, HIGH);
//                      break;
//                         case 6:
//                         digitalWrite(A6, HIGH);
//                         break;
//                            case 7:
//                            digitalWrite(A7, HIGH);
//                            break;
//                 }
//                       }

   
void loop(){

  
        stateA = digitalRead(pinA);
 
       if ((pinALast == HIGH) && (stateA == LOW)) {
          if (digitalRead(pinB) == HIGH) {  
            if(encoderPos <= 21) {encoderPos = 21;}
      encoderPos = encoderPos - 21;
           } else {
             if(encoderPos >= 234) {encoderPos = 234;}
      encoderPos = encoderPos + 21;
                   }
                                                   }
 
       pinALast = stateA;
 
// the previous part is the same as the interrupt for reading the encoder: I added again because, for some misterious reason..., this improve the reliability of reading!

pot = encoderPos;
DigitalPotWrite(BOTH_POT_SEL , pot);

if(encoderPos != previousEncoderPos) {RGB(encoderPos);}

// ledVol(encoderPos/32);


  while (digitalRead(encoderButton) == LOW ){ delay(100);   
                                             lenghtPush = lenghtPush + 100;  
                    if (lenghtPush > longPush)        // ready to FADE
                       {Blue(255);}                      // Blue LED
                    if (lenghtPush >= 7000)           // ready to store in EEPROM
                       {RGBall(255);}                 // all LED
                    if (stopCount == 1) {Green(); digitalWrite(reedStop, LOW);}    // after first STOP 
                                                                                   // ready to CLEAN -> green LED                 
                                            } 
   digitalWrite(reedStop, noExt);
  
   if (stopCount == 1 && noExt == 0)   // ignore short press if external STOP connected
      {stopCount = 0; Green();}
   
   if (stopCount == 1 && lenghtPush >= longPush)
      {lenghtPush = 0; stopCount = 0; Green();}


  // **************    encoder button pressed for LONG --> Activate  FADE out   ********************
        
        if (lenghtPush >= longPush){
   
                               if (lenghtPush >= 7000) {  // press encoder Button for more than 7s 
                                                          // to store the encoder position in the EEPROM for potValue             
                               EEPROM.update(0, encoderPos);
                               RGBall(255);  
                               delay(750);
                               RGBall(0);
                               delay(750);
                               RGBall(255); 
                               delay(750);
                               Green(); 
                               goto label;         } 

               Blue(pot);            // FADE out in progress
                              
               // change the resistance on BOTH_POT from encoderPos to min:                             
               for (int pot = encoderPos; pot >= 0; pot--) {
               DigitalPotWrite(BOTH_POT_SEL , pot);
               Blue(pot);
               // ledVol(pot/32);
                 
               delay(timeFade);

               stopState = digitalRead(stopTip);
               delay(10);
               if(stopState == HIGH && noExt == 0 || digitalRead(encoderButton) == LOW) {Green(); 
                                                                                         goto label;} 
                                                            }
                   //  Green();
                     stopCount = 1;
                     goto label;
                                          }
                                
  // **************   encoder button pressed SHORT -> STOP Boss RC-1   **************************
 
        else if(lenghtPush >= shortPush){ 
                                         stopCount = 1;      // stop pressed                                                          
                                         Red();
                                       
             label:                                                    
                                         digitalWrite(reedStop, LOW);
                                         delay(100);
                                         DigitalPotWrite(BOTH_POT_SEL , encoderPos);
                                         digitalWrite(reedStop, noExt);                                                   
                                         }
  
          lenghtPush = 0;

// ******************************************************* External FADE switch (RING) *********************

 if(noRing == 0){ //  if external FADE (RING) switch connected
   
   ringState = digitalRead(fadeRing);
   stopState = digitalRead(stopTip);
   delay(175);
           if(ringState == HIGH) { Count++; }
           if(stopState == HIGH) { Count = 0; Green();}
   labelE:
   
           switch (Count) {
                       case 0:
                       
                       break;
                              case 1:
                              Blue(fade);
                              // change the resistance on BOTH_POT from potFade to min:
                              
                              for (fade = potFade; fade >= 0; fade--) {
                              DigitalPotWrite(BOTH_POT_SEL , fade);
                              
                            //  ledVol(fade/32);
                              delay(timeFade);
                              Blue(fade); 
                              
                              stopState = digitalRead(stopTip);
                              if(stopState == HIGH) { Count = 0; potFade = encoderPos; goto labelE;}

                              ringState = digitalRead(fadeRing);
                              if(ringState == HIGH) { Count = 2; inter = fade; goto labelE;}    
                                                                                  }
                              Green();
                              potFade = 0; // with external FADE switch it remains at min vol
                                           // until press FADE again -> volume increases progressively (FADE in)
                                           // or press STOP -> volume goes to max
                              goto labelE;
                              
                              break;  
                                     case 2:  
                                     // change the resistance on BOTH_POT from min to potValue:
                                     for (fade = inter; fade <= encoderPos; fade++) {
                                     DigitalPotWrite(BOTH_POT_SEL , fade);
                                     delay(timeFade);
                                     Blue(fade);
                                  //   ledVol(fade/32);
                                                                                     }
                                     Green();
                                     Count = 0;
                                     potFade = encoderPos;
                                     break;
                            }
               }
}        
